// if user is running mozilla then use it's built-in WebSocket
window.WebSocket = window.WebSocket || window.MozWebSocket;

var connection = new WebSocket('ws://127.0.0.1:7777');

connection.onopen = function () {
   // connection is opened and ready to use
   console.log("Connected");
};

connection.onerror = function (error) {
    // an error occurred when sending/receiving data
    console.log("Connection Error");
};

connection.onclose = function (error) {
    players.splice(0, players.length);
    redrawScreen = true;
    console.log("Disconnected");
};

connection.onmessage = function (message) {
    try {
        var json = JSON.parse(message.data);
        var title = json.title;
        var msg = json.msg;
        if (title == "connected") {
            var p = new Player();
            p.uID = msg.uID;
            p.x = msg.x;
            p.y = msg.y;
            players.push(p);
            redrawScreen = true;
        }
        if (title == "disconnected") {
            RemovePlayer(GetPlayerFromUID(msg.uID));
            redrawScreen = true;
        }
        if (title == "update") {
            var p = GetPlayerFromUID(msg.uID);
            p.x = msg.x;
            p.y = msg.y;
            redrawScreen = true;
        }
    } catch (e) {
        console.log('This doesn\'t look like a valid JSON: ', message.data);
        return;
    }
};

function Send(title, msg) {
   connection.send(JSON.stringify({ title:title, msg: msg }));
}

function Player () {
    this.uID = 0;

    this.x = 0;
    this.y = 0;
}
function RemovePlayer(p) {
   players.splice(players.indexOf(p), 1);
}
function GetPlayerFromUID(uID) {
	for (var i = 0; i < players.length; i++) {
		if (players[i].uID == uID) {return players[i];}
	}
	return null;
}